=== modified file 'src/com/goldencode/p2j/schema/SchemaDictionary.java'
--- old/src/com/goldencode/p2j/schema/SchemaDictionary.java	2021-04-13 00:57:06 +0000
+++ new/src/com/goldencode/p2j/schema/SchemaDictionary.java	2021-04-13 20:30:32 +0000
@@ -499,6 +499,9 @@
 **    CA   20201011          Scope.promoted changed to an identity hash set.
 **    CA   20201015          Replaced java.util.Stack with a non-synchronized custom implementation.
 **     AIL 20210309          Clean local schema dictionary instances. 
+**    GES  20210208          Added table-level signature calculation (saved as an annotation). Added
+**                           findTableInfo() to provide a set of related data about a matched record. This
+**                           saves multiple calls each having to resolve the same name node lookup.
 */
 
 /*
@@ -1765,6 +1768,9 @@
       {
          copyTableProperties(ast, table);
       }
+      
+      // calculate and save the table signature
+      calculateSignature(table);
 
       if (modelTable == null)
       {
@@ -1916,6 +1922,65 @@
    }
    
    /**
+    * Get the Progress parser token type of a table, temp-table, work-table,
+    * or buffer. If <code>name</code> represents a buffer, the type of the
+    * backing record is returned. That is, a type of <code>BUFFER</code> is
+    * never returned, only the type of the record which backs the buffer.
+    * <p>
+    * If both forceTemp and forcePersistent are <code>false</code>, then the lookup is performed
+    * with no preference for temp-table or persistent table.
+    *
+    * @param   name
+    *          Case insensitive record name; may be qualified or not. If
+    *          qualified, only the table portion of the name may be
+    *          abbreviated.
+    * @param   forceTemp
+    *          If <code>true</code>, force a temp-table lookup.
+    * @param   forcePersistent
+    *          If <code>true</code>, force a persistent table lookup.
+    *
+    * @return  One of the Progress parser token types <code>TABLE</code>,
+    *          <code>TEMP_TABLE</code>, or <code>WORK_TABLE</code>, or
+    *          <code>UNKNOWN</code> if <code>name</code> cannot be found.
+    *
+    * @throws  AmbiguousSchemaNameException
+    *          if <code>name</code> is an ambiguous identifier for the
+    *          target record.
+    */
+   public TableInfo findTableInfo(String name, boolean forceTemp, boolean forcePersistent)
+   throws AmbiguousSchemaNameException
+   {
+      // TODO: The recordType lookup used scopes.size() - 1 instead of nearestEnclosingInternal(), is this
+      //       an issue?  It seems like it should have been consistent with the other lookups, so this is
+      //       being made consistent here.
+      int l1 = computeLevel(forceTemp, forcePersistent, true, nearestEnclosingInternal());
+      int l2 = computeLevel(forceTemp, forcePersistent, false, SCHEMA_GLOBAL_SCOPE);
+
+      // Look up record name node.
+      NameNode node = findEntry(name, EntityName.TABLE, l1, l2, false);
+      
+      TableInfo info = null;
+      
+      if (node != null)
+      {
+         NameNode dbNode  = node.getParent();
+         
+         // don't just use getAst() here, we need the AST for the backing table if this is a buffer
+         // (this will work for both the simple case and the buffer case)
+         Aast   ast   = getTable(node); 
+         String sig   = ast != null ? (String) ast.getAnnotation("signature") : null;
+         String sname = getQualifiedName(node);
+         String bname = getRecordName(node, EntityName.TABLE, name);
+         String dname = (dbNode != null) ? dbNode.getName() : "";
+         int    ttype = getTable(node).getType();
+         
+         info = new TableInfo(sig, sname, bname, dname, ttype);
+      }
+      
+      return info;
+   }
+   
+   /**
     * Get an object which exposes schema-related information about a field which is referenced in
     * source code.
     * 
@@ -4908,6 +4973,74 @@
    }
    
    /**
+    * Calculate and save the signature for the table.  Each field is represented by "datatype" or
+    * "datatype[extent]" format.  The table level signature is all of the field signatures separated
+    * by "|" delimiter with the number and order of the fields matching the order in the AST.
+    *  
+    * @param    table
+    *           The table AST substree.
+    */
+   private void calculateSignature(Aast table)
+   {
+      String signature = "";
+      
+      Aast next = (Aast) table.getFirstChild();
+
+      // iterate through all fields
+      while (next != null)
+      {
+         int type = next.getType();
+         
+         // if this is a field, calculate the field's portion of the signature
+         if (type >= BEGIN_FIELDTYPES && type <= END_FIELDTYPES ||
+             type >= BEGIN_METATYPES  && type <= END_METATYPES)
+         {
+            Aast ext = next.getImmediateChild(KW_EXTENT, null);
+            
+            String extent = null;
+            
+            // read the extent value if any
+            if (ext != null)
+            {
+               if (ext.getNumImmediateChildren() == 0)
+               {
+                  String err = String.format("Indeterminate EXTENT in a temp-table definition for %s",
+                                             next.dumpTree());
+                  
+                  // indeterminate extent does not make sense for a temp-table, should not happen
+                  throw new RuntimeException(err);
+               }
+               else
+               {
+                  // the only child is a NUM_LITERAL
+                  Aast num = (Aast) ext.getFirstChild();
+                  extent = num.getText();
+               }
+            }
+            
+            // create the field portion of the signature
+            String fsig = SchemaParser.fieldSignature(type, extent);
+            
+            // add it in to the table signature
+            signature += (signature.length() == 0) ? fsig : "|" + fsig;
+         }
+
+         next = (Aast) next.getNextSibling();
+      }
+
+      // save the result
+      if (signature.isEmpty())
+      {
+         // there should always be at least 1 field
+         throw new RuntimeException(String.format("Invalid temp-table, no fields!\n%s", table.dumpTree()));
+      }
+      else
+      {
+         table.putAnnotation("signature", signature);
+      }
+   }
+   
+   /**
     * Copy TABLE properties from a source AST to a destination AST. The set
     * of properties (essentially child AST nodes) copied will be limited to
     * those that are valid in a table (filtered by token type). It is assumed

=== added file 'src/com/goldencode/p2j/schema/TableInfo.java'
--- old/src/com/goldencode/p2j/schema/TableInfo.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/schema/TableInfo.java	2021-04-09 17:19:41 +0000
@@ -0,0 +1,166 @@
+/*
+** Module   : TableInfo.java
+** Abstract : Schema information about a database field.
+**
+** Copyright (c) 2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- --------------------------------Description----------------------------------
+** 001 GES 20210224 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.schema;
+
+/**
+ * A read-only bean which exposes schema-related information associated with a database table
+ * which is referenced in source code.
+ */
+public class TableInfo
+{
+   /** Table signature associated with the table. */
+   private final String signature;
+   
+   /** Fully qualified schema name of the table. */
+   private final String qualified;
+   
+   /** Table's buffer name as indicated in source. */
+   private final String buffer;
+   
+   /** Table's database logical name or alias. */
+   private final String database;
+   
+   /** Table's token type. */
+   private final int recordType;
+   
+   /**
+    * Constructor.
+    * 
+    * @param   signature
+    *          Structural signature for the table.
+    * @param   qualified
+    *          Fully qualified schema name of the table.
+    * @param   buffer
+    *          Name of the buffer indicated by the table reference in source code.
+    * @param   database
+    *          Name of the database which contains the table, as specified by the table reference
+    *          in source code, or looked up if the source reference was unqualified.
+    * @param   recordType
+    *          Token type of the table backing the buffer indicated by the table reference in
+    *          source code.
+    */
+   TableInfo(String signature, String qualified, String buffer, String database, int recordType)
+   {
+      this.signature  = signature;
+      this.qualified  = qualified;
+      this.buffer     = buffer;
+      this.database   = database;
+      this.recordType = recordType;
+   }
+   
+   /**
+    * Get the signature of the table in the schema.
+    * 
+    * @return   Table signature.
+    */
+   public String getSignature()
+   {
+      return signature;
+   }
+   
+   /**
+    * Get the fully qualified schema name of the field.
+    * 
+    * @return  Qualified field name.
+    */
+   public String getQualified()
+   {
+      return qualified;
+   }
+   
+   /**
+    * Get the buffer name associated with the field.
+    * 
+    * @return  Buffer name.
+    */
+   public String getBuffer()
+   {
+      return buffer;
+   }
+   
+   /**
+    * Get the logical database name or alias, if any, associated with the field.
+    * 
+    * @return  The logical name of the database associated with the buffer associated with the
+    *          field. An empty string is returned if the containing table is a temp- or
+    *          work-table.
+    */
+   public String getDatabase()
+   {
+      return database;
+   }
+   
+   /**
+    * Get the Progress parser token type of a table, temp-table, work-table, or buffer which
+    * contains the field. If the record containing the field is a buffer, the type of the backing
+    * record is returned. That is, a type of {@code BUFFER} is never returned, only the type of
+    * the record which backs the buffer.
+    * 
+    * @return  Record token type.
+    */
+   public int getRecordType()
+   {
+      return recordType;
+   }
+}
\ No newline at end of file

